\documentclass[11pt]{article}
%%%%%%%%%%%%%%%%%%%%%%%%%
%			AZ' STANDARD NEWCOMMANDS
%%%%%%%%%%%%%%%%%%%%%%%%%
%\usepackage[latin1]{inputenc}
\usepackage[english]{babel} 
\usepackage[T1]{fontenc}
\usepackage{cite, url,color} % Citation numbers being automatically sorted and properly "compressed/ranged". 
%\usepackage{pgfplots}
\usepackage{graphics,amsfonts}
\usepackage[pdftex]{graphicx}
\usepackage[cmex10]{amsmath}
% Also, note that the amsmath package sets \interdisplaylinepenalty to 10000
% thus preventing page breaks from occurring within multiline equations. Use:
 \interdisplaylinepenalty=2500
% after loading amsmath to restore such page breaks as IEEEtran.cls normally does.
\usepackage{hyperref}
\usepackage[utf8]{inputenc}
%% Useful packages for creation of two-column and more complex figures

% Compact lists
\usepackage{enumitem}

%\usepackage{./AZmacro}
%\usepackage{/Users/AZ/SVN/zanella_svn/zanella_paper/IEEETrans/algorithmic}
%\usepackage[named]{/Users/AZ/SVN/zanella_svn/zanella_paper/IEEETrans/algo}
% algorithmic.sty was written by Peter Williams and Rogerio Brito.
% This package provides an algorithmic environment fo describing algorithms.
% You can use the algorithmic environment in-text or within a figure
% environment to provide for a floating algorithm. Do NOT use the algorithm
% floating environment provided by algorithm.sty (by the same authors) or
% algorithm2e.sty (by Christophe Fiorio) as IEEE does not use dedicated
% algorithm float types and packages that provide these will not provide
% correct IEEE style captions. The latest version and documentation of
% algorithmic.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithms/

\usepackage{array}
% http://www.ctan.org/tex-archive/macros/latex/required/tools/
\usepackage{mdwmath}
\usepackage{mdwtab}
%mdwtab.sty	-- A complete ground-up rewrite of LaTeX's `tabular' and  `array' environments.  Has lots of advantages over
%		   the standard version, and over the version in `array.sty'.
% *** SUBFIGURE PACKAGES ***
\usepackage[tight,footnotesize]{subfigure}

\usepackage[top=3cm, bottom=3cm, right=3cm,left=3cm]{geometry}
\usepackage{indentfirst}

\usepackage{times}
%\usepackage[active]{srcltx}
\graphicspath{{./figure/}}

\setlength\parindent{0pt}
\linespread{1}

\def\C#1{\mathcal{#1}}

\renewcommand{\phi}{\varphi}
% OPERATORS
\newcommand{\floor}[1]{{\left\lfloor #1\right\rfloor}}
\newcommand{\ceil}[1]{{\left\lceil #1\right\rceil}}
\newcommand{\E}[1]{\mathop{\rm E}\nolimits\left[#1\right]} % Expectation
\newcommand{\pr}[1]{\Pr\left[ #1 \right]}
\renewcommand{\P}[1]{\mathrm{P}\left[ #1 \right]}

\newcommand{\mbb}{\mathbb}
\newcommand{\mrr}{\mathrm}
\newcommand{\mmin}[1]{{\min\left\{#1\right\}}}
\newcommand{\mmax}[1]{{\max\left\{#1\right\}}}
\newcommand{\id}[1]{\mathbf{1}\(#1\)} % Unit function  
\newcommand{\Heav}[1]{\mathcal{H}\left(#1\right)} % Heaviside function
\newcommand{\eps}{\varepsilon}
\newcommand{\rect}[1]{\mathrm{rect}\!\left(#1\right)}
\newcommand{\sinc}[1]{\mathrm{sinc}\!\left(#1\right)}
\newcommand{\bin}[2]{{\left(\begin{array}{c}#1\\#2\end{array}\right)}}

\newcommand{\me}[2]{\left[ {#1} \right]_{(#2)}} % Submatrix \me{P}{i,j} produces [P]_{i,j} and denotes the element in the i-th row and j-th column of P
\newcommand{\vv}[1]{\left[ {#1} \right]} % Submatrix \vv{a,b,c} produces [a,b,c]

\newcommand{\Set}[1]{{\C #1}} 
\newcommand{\Setd}[2]{\Set{#1}=\left\{#2\right\}}  % Set definition: \Set{S}{0,1,2} produces S={01,2,} where S is in mathcal 

\newcommand{\mat}[1]{{\hbox{\textbf{#1}}}}
\newcommand{\ei}[1]{{\mat{e}_{#1}}}   % all zero vector except in the $#1$-th element which is one
\newcommand{\ind}[1]{\mathbf{\chi}\left\{#1\right\}} % Indicator function \ind{A}=1 if A is true, \ind{A}=0 otherwise. 

% FORMATTING
\newcommand{\ie}{i.e.,\,}
\newcommand{\eg}{e.g.,\,}
\newcommand{\columnbreak}{\vfill\eject} % Column break

% REFERENCES
\newcommand{\Fig}[1]{Fig.~\ref{#1}}
\newcommand{\eq}[1]{(\ref{#1})}
\newcommand{\Tab}[1]{Tab.~\ref{#1}}
\newcommand{\Sec}[1]{Sec.~\ref{#1}}

% COMMENTS/REVISIONS
\newcommand{\AZ}[1]{\textit{\color{magenta}AZ says: #1}} 

\newif\ifcutshort
\cutshortfalse
\newcommand{\CS}[1]{\ifcutshort \else #1 \fi}   % cutshort

\newif\ifsol
\soltrue

\begin{document}
\title{Network Science  - AY 2019/2020\\
Homework 2: Telecommunications Network}
\author{Michael Neri ID 1232224}
\date{13 December 2020}
\maketitle
\newpage
\tableofcontents
\newpage
\section{Abstract}
This homework continues the study of a Telecommunications network using methods studied in the $2^{nd}$ part of the course of Network Science. We will see results of applying algorithm of Ranking, Community Detection and Link Prediction starting from the Adjacency Matrix $A$ in Fig.\ref{Adj}.

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{OldMatrix} 
\caption{Starting Adjacency Matrix.}
\label{Adj}
\end{figure}


\section{Ranking}
Links in a Telecommunication network represent either logical or physical connections between devices in the graph. Since in this typology of network communications are full duplex (using for istances TCP protocol), we can assume that links are undirected. For this reason, we are going to use only the PageRank's algorithm in order to rank the nodes since HITS requestes a directed one for detecting authorities and hubs. 

\subsection{PageRank}
PageRank is an algorithm in order to sort nodes on the basis of the concept of popularity. It is defined as a stochastic processes and can be represented as a Time Discrete Markov Chain where the time is determined as a jump of a random surfer of the network. PageRank's values are so the steady-state probability distribution of the process.

In terms of a Telecommunications Network, PageRank evaluates the probability of a random packet to be in the device's queue after a lot of discrete steps.

The stochastic Matrix is defines as follow 
\begin{equation}\label{StochProc}
\mathbf{M} = \mathbf{A}diag^{-1}(\mathbf{d})
\end{equation} 
where $\mathbf{A}$ is the adjacency matrix of the network and $\mathbf{d}$ is the vector containing all the degrees of nodes. $diag^{-1}$ is a function that transform the vector $\mathbf{d}$ in a diagonalized matrix where the entries in the diagonal are the inverse of vector in the parameter.

The PageRank equation to be solved is
\begin{equation}\label{PageRankEquation}
\mathbf{r} = c\mathbf{M}\mathbf{r} + (1-c) \mathbf{q}
\end{equation}
where $\mathbf{r}$ is the vector $N$x$1$ containing all the PageRank's values of the nodes, $\mathbf{M}$ is the stochastic process defined in (\ref{StochProc}), $c = 0.85$ is a constant value which is defined as a dumping factor where a random surfer jumps to one of the links of the graph 85\% of the times. 

The vector $\mathbf{q}$, with dimensions $N$x$1$, is the teleportation vector which permits to the surfer to jump across the network randomly. For PageRank, we set this value uniformly for each node of the network.

We have to remember that the vector $\mathbf{r}$ must be a probabilistic vector so
\begin{equation}
\sum_{j = 1}^{N} r_j = 1
\end{equation}

PageRank procedure can be solved for obtaining the vector $\mathbf{r}$ using two specific methods: power iteration or solving the linear equation cited in (\ref{PageRankEquation}).
\begin{figure}[h]
	\centering
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=\textwidth]{2ndEig}
		\caption{Convergence of the second highest eigenvalue.}
		\label{2Eigen}
	\end{minipage}
	\hfill
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=\textwidth]{PageRankEig}
		\caption{Eigenvalues of PageRank.}
		\label{Eigen}
	\end{minipage}
\end{figure}

\subsubsection{Power Iteration}

Using the power iteration, we can evaluate the evolution of the ranking vector $\mathbf{r}$ by letting surf the network to our packet step by step. At the beginning we set the initial value of $\mathbf{r_0}$  with value with parameter $\frac{1}{N}$ for each entry of the vector (the same must be done with the teleportation row). After the initial state, we run the PageRank algorithm using the iteration as below
\begin{equation}
\mathbf{r_{t+1}} = c\mathbf{M}\mathbf{r_{t}} + (1-c) \mathbf{q}
\end{equation}
After $t = 40$ steps, we can assume that $p_{t_{40}}  \approx p_{\infty}$ with a little bit of error which is evaluated in the Fig.\ref{2Eigen} where it is displayed the convergence of the second highest eigenvalue of the matrix $\mathbf{M}$. In Fig.\ref{Eigen} there is also the plot of all the eigenvalues of PageRank. Since it is a stochastic processes, it must be present the eigenvalue $\lambda = 1$.

Since this method approximate the value of popularity after a fixed number of steps, if we want the exact value of the ranking vector, we must solve directly the linear equation defined in (\ref{PageRankEquation}).


\subsubsection{Solving Linear Equation}
Using this method, we can obtain the exact value of popularity of the devices in the generated telecommunications network. Observing the peaks of the plot in Fig.\ref{plotPage}, we can ascertain that the nodes with a high popularity are the routers of the LAN. 

We can use this algorithm also to distinguish between end devices and intermediary nodes since packets are more likely to be in routers or in switches during the transmission time. 

For this reason, a threshold is plotted in order to recognize routers instead of looking at the script developed in HW1.

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{PageRankProbwithThreshold} 
\caption{PageRank values.}
\label{plotPage}
\end{figure}

\subsection{SimRank}
SimRank is an algorithm which evaluates similarity between nodes in the network. It is based on the PageRank algorithm since the difference is in the teleportation vector.

If we want to evaluate SimRank values, teleportation vector $\mathbf{q}$ must have only a $1$ in the node where we want to measure similarity and run the same PageRank algorithm.

This procedure has to be run for each node of the network. A matrix $N$x$N$ is obtained because $N$ probabilistic columns are performed. The entry $simrank_{i,j}$ measures similarity between node $i$ and $j$.

This algorithm is very useful for next topic as it can be used in order to divide the network in communities and in the Link Prediction topic (Random Walk based algorithms).

\begin{figure}[h]
	\centering
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=\textwidth]{SimRank}
		\caption{3D SimRank matrix.}
		\label{SimRank}
	\end{minipage}
	\hfill
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=\textwidth]{SimRank2D}
		\caption{2D SimRank matrix.}
		\label{SimRank3D}
	\end{minipage}
\end{figure}

As we can see from pictures Fig.\ref{SimRank3D} and Fig.\ref{SimRank}, nodes are more related with their own neighbours since non-negligible values are read on the diagonal of the matrix. These can be explained by the physical links of the LANs.

Some minor values are distant from the diagonal since they represent logical links which can be established between nodes across the graph.


\section{Community Detection}
In this section we are going to divide the network in communities on the basis of three algorithms: PageRank nibble, Spectral Clustering and Modularity. 
A Telecommunication network is a very structural network and finding communities is likely to find all the different LANs of the graph. 
What we expect from the analysis is to find approximately 30 LANs which is the number defined in the generation script of HW1. At the beginning we will try to split the network in two parts.

\subsection{PageRank nibble}
Using this method we are going to split the network into two main partitions: Core Network and External Network. In a centralized industrial network, Core Network has all the main routers and nodes which represent the backbone of communications and services. 

If we think about an enterprise company, the Core network is the set of nodes which belong to the headquarter meanwhile the External Network is the set of devices in the branches.

\begin{figure}[h]
	\centering
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=\textwidth]{Conductancenibble}
		\caption{Conductance of PageRank-nibble.}
		\label{ConductanceNibble}
	\end{minipage}
	\hfill
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=\textwidth]{PagerankNibble}
		\caption{Core \& Internal Network partitions.}
		\label{PageRankNibble}
	\end{minipage}
\end{figure}
As we can see from the plot in Fig.\ref{ConductanceNibble}, we can split the network in two parts using the minimum value of the conductance. Using this relevant piece of information, we can divide the network in the way illustrated in Fig.\ref{PageRankNibble}.

\begin{itemize}
\item Community size \#1 (Core Network): 131
\item Community size \#2 (External Network): 1898
\end{itemize}

\subsection{Spectral Clustering}
Thanks to the Spectral Clustering, we are going to divide the network in order to detect LANs. First of all we have to inspect the conductance of this algorithm for the purpose of locating good communities. 
As we can clearly see from Fig.\ref{SweepCO}, lots of local minimum are found which means newtork can be divided in more than two communities. 

Since the conductance is already sorted, communities can be identified by taking the intervals from one minimum to the next one. A threshold is configured in order not to take bad splitting intervals.

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{FirstConductanceSweep} 
\caption{Conductance of Spectral Clustering.}
\label{SweepCO}
\end{figure}

Thanks to this algorithm, we have detected 32 communities which can be very plausible with respect to our expectation. In Fig.\ref{commu} are displayed all the partitions of the network. On the x-axis is plotted the ID of the node meanwhile community ID is assigned to y-axis.

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{communities} 
\caption{Plot of the 32 communities.}
\label{commu}
\end{figure}

We have to remark that the previous procedure is an approximation of a possible division of the network since if we compare the adjacency matrix with the communities, we can detect some differences but still pretty reasonable. 

One main difference is the presence of a very big community which contains approximately 900 hosts whereas it is not present in the adjacency matrix. This issue can be explained by the approximation of the algorithm and random logical connections.



\subsection{Modularity}
In HW2, Modularity is implemented in order to split the network in two communities using an alternative algorithm. 

It is a very efficient method but it has a resolution limit which does not perform properly with small clusters. For this reason, the network will be divided in two parts in order to compare results with PageRank-Nibble clustering.

We assign a community membership signal $s_1 = 1$ or $s_2 = -1$ to each node and we define the matrix's entries of $\mathbf{B}$ as follow
\begin{equation}
B_{ij} = a_{ij}-\frac{k_ik_j}{2L} 
\end{equation} 
where $a_{ij}$ is the entry of the binary adjacency matrix, $k_i$ is the degree of the i-th node and $L$ is the number of links. 
Community membership signals depend on the eigenvector of the matrix $\mathbf{B}$.

From these values, we are going to evaluate modularity value which is defined as
\begin{equation}
Q = \frac{\mathbf{s^TBs}}{4L}
\end{equation}
where $\mathbf{s}$ is the community vector containing $-1$ or $1$. 

This value, which is the denoted as $Q$, is a real number and must be
$$
-1 < Q < 1
$$
where $Q\in [0.3,0.7]$ means good fitting of the community detected. 

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{ModCom} 
\caption{Detection of two communities by Modularity.}
\label{ModCom}
\end{figure}

In Fig.\ref{ModCom} is visualized the plot of the network splitted in two subnetworks. The value of Q for this division is $Q = 0.30149$ which means that something can be improved and the network can be divided in more subnetworks. With respect to the result obtained by PageRank-nibble algorithm in Fig.\ref{PageRankNibble}, we can see that different approaches give different communities but the network is always divided into two parts where one is larger than the other.

\section{Link Prediction}
This part of the report is centered around link prediction algorithms which can provide a tool in order to understand the future connections of the network. Mainly, we are going to evaluate the probability of activation for each possible link of the graph. 

There are a lot of possible implementations based on specific parameters of the networks. Next subsections will provide more information about each single procedure. Each method provides a matrix $\mathbf{S}$ where each entry $S_{ij}$ is the activation probability from node $i$ to node $j$.

\begin{center}
\begin{tabular}{|l|l|}
\hline
Link Prediction Algorithm                                                                                   & Average \# of new links           \\ \hline
Common Neighbour                                                                                   & 6559           \\ 
Adamic Adar                                                                                    & 6604           \\ 
Resource Allocation                                                                               & 6543        \\ \hline
Kats                                                                                   & 4582           \\ 
Local Path                                                                                                   & 6349        \\ \hline
Random Walk with Restart                                                         & 6127      \\ \hline


\end{tabular}
\medskip

Tab. 1.1: New connections created by each algorithm.
\label{TabLink}
\end{center}

Next step is to implement a tool for evaluating the correctness of the prediction and to see which is the best algorithm for a Telecommunications Network.

\subsection{Neighbour based Techniques}

\subsubsection{Common Neighbour}
It is the simplest algorithm to implement. It takes care only on neighbours and its matrix is defines as
\begin{equation}
\mathbf{S_{CN}} = \mathbf{A}*\mathbf{A}
\end{equation}
Its computational complexity is very low since it is only a single matrix multiplication between adjacency matrix $\mathbf{A}$ with itself. For our network, we can assume a priori as a good prediction technique only for links beloging to the same LANs.
In Fig.\ref{commonNeigh} is displayed the entries of the matrix.

\subsubsection{Adamic Adar}
Adamic Adar is based on the concept that less-connected neighbours are more likely to be connected with a new link. For this reason, entries of matrix $\mathbf{S_{AA}}$ are evaluated using
\begin{equation}
S_{AA}(i,j) = \sum_{k \in N_i \cap Nj }^{} \frac{1}{ln(N_k)}
\end{equation}

In Fig.\ref{AdamicA}  entries of the matrix are plotted.

\subsubsection{Resource Allocation}
If two nodes $i$ and $j$ have a common neighbour which has an high degree, with Resource Allocation method, then a connection between them will be very unlikely.
\begin{equation}
S_{RA}(i,j) = \sum_{k \in N_i \cap Nj }^{} \frac{1}{|N_k|}
\end{equation} 

In Fig.\ref{ResourceA} entries of the matrix are graphed.

After all these evaluations using Common Neighbour paradigm, we can certify that our initial assumption was wrong since the three matrix are not very similar to the adjacency matrix $\mathbf{A}$. These method can be used only for predict future physical links.

\begin{figure}[!htb]
\minipage{0.32\textwidth}
  \includegraphics[width=\linewidth]{CommonNeigh.png}
  \caption{$\mathbf{S_{CN}}$ matrix.}\label{commonNeigh}
\endminipage\hfill
\minipage{0.32\textwidth}
  \includegraphics[width=\linewidth]{AdamicA.png}
  \caption{$\mathbf{S_{AA}}$ matrix.}\label{AdamicA}
\endminipage\hfill
\minipage{0.32\textwidth}%
  \includegraphics[width=\linewidth]{ResourceA.png}
  \caption{$\mathbf{S_{RA}}$ matrix.}\label{ResourceA}
\endminipage
\end{figure}

\subsection{Path based Techniques}
Besides the previous subsection, Path based Techniques take into account the links of network in order to evaluate the great number of paths of length $l$. We also set $\beta = 0.8$.
\subsubsection{Kats}
Setting $l = 3$, Kats' matrix is computed using the following formula
\begin{equation}
\mathbf{S_{Kats}} = \sum_{k =1}^{l}\beta^k\mathbf{A}^k
\end{equation}
Kats' matrix is shown in Fig.\ref{KatsA}.
\subsubsection{Local Path}
Local Path's matrix is evaluated as follow
\begin{equation}
\mathbf{S_{LP}} = \mathbf{A}^2+\beta \mathbf{A}^3
\end{equation}

\begin{figure}[!htb]
\minipage{0.5\textwidth}
  \includegraphics[width=\linewidth]{Kats.png}
  \caption{$\mathbf{S_{Kats}}$ matrix.}\label{KatsA}
\endminipage\hfill
\minipage{0.5\textwidth}
  \includegraphics[width=\linewidth]{LocalPath.png}
  \caption{$\mathbf{S_{LP}}$ matrix.}\label{LocalA}
\endminipage\hfill
\end{figure}

A better prediction is provided by using Path Based algorithm instead of Common Neighbour.
A good match with adjacency matrix is obtained by running Kats.
\subsection{Random Walk based Technique}
\subsubsection{Random Walk with restart}
Thanks to SimRank, we can evaluate the probability of activation using SimRank's values obtained at the beginning of the script. Entries of the matrix $\mathbf{S_{RWR}}$ are defined as follow
\begin{equation}
S_{RWR}(i,j) = simrank(i,j)+simrank(j,i)
\end{equation}

As we can clearly see, $\mathbf{S_{RWR}}$ is a symmetrical matrix because of its definition (i.e. $S_{RWR}(i,j) = S_{RWR}(j,i)$). 
 
\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{RandomWalkTech} 
\caption{$\mathbf{S_{RWR}}$ matrix.}
\label{RandomWalkLink}
\end{figure}

From Fig.\ref{RandomWalkLink}, we can spot the highest similarity between $\mathbf{S_{RWR}}$ and the adjacency matrix which it makes us suppose that this method could be the best for link prediction of a Telecommunications Network.

\subsection{AUC}
Looking at similarity between $\mathbf{S}$'s matrices and adjacency is not a sufficient method to check correctness of the prediction.
AUC is implemented in order to evaluate mathematically the performance of each algorithm.
We divide the link's network in three parts:
\begin{itemize}
\item \textit{P}robe set. 10\% of the active links are disactivated.
\item \textit{T}est set in which 90\% of the active links are stored.
\item \textit{I}nactive set where there are all the inactive links of the network.
\end{itemize}
After this partition, we run all the link prediction algorithm and we evaluate AUC as follow
\begin{equation}
AUC = \frac{1}{|\mathit{P}||\mathit{I}|} \sum_{p \in \mathit{P}, i \in \mathit{I}}^{} (S(p)>S(i)?1:0)
\end{equation}
where $\mathbf{S}$ is the link prediction matrix obtained by a generic algorithm. $(S(p)>S(i)?1:0)$ is a reduced form to account the number of good predictions. If the algorithm thinks that a link  $p \in \mathit{P}$ has a greater probability to be established than another link $i \in \mathit{I}$, then a counter is increased by one, by zero otherwise.

Thanks to this powerful tool, we obtained a chart which is illustrated in Fig.\ref{auc}. We can now say for sure that the best algorithm for link prediction for a Telecommunications Network is the \textit{Random Walk with restart} technique, using a Probe set of 10\% of the total active links.

We have to remark that Kats can be also a very good predictor since it gets approximately an AUC of 56\% using less fresh links than the Random Walk.

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{auc} 
\caption{AUC measures for each paradigm with 10\%.}
\label{auc}
\end{figure}

Increasing the percentage of the Probe set, we can see from Fig.\ref{auc20} that Neighbour based Techniques perform at the same way since their AUC is approximately equal.
Using Path based Algorithm, we obtain a better prediction with Kats, which reaches 59\%, and Local Path. Random Walk based algorithm is still the best to use but it loses a little of its performance.

\begin{figure}[h]
\centering
\includegraphics[scale=0.5]{auc20} 
\caption{AUC measures for each paradigm with 20\%.}
\label{auc20}
\end{figure}
\section{References}

\url{http://networksciencebook.com}


\end{document}
